package tests;

import models.Counter;
import static org.junit.Assert.*;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author forellana
 */
public class CounterTest {

    private Counter counter;

    @Before
    public void setUp() {
        this.counter = new Counter();
    }

    @Test
    public void add1() {
        assertEquals(this.counter.getCount(), 0);
        this.counter.add1();
        assertEquals(this.counter.getCount(), 1);
        this.counter.add1();
        this.counter.add1();
        assertEquals(this.counter.getCount(), 3);
    }

    @Test
    public void sub1() {
        assertEquals(this.counter.getCount(), 0);
        this.counter.sub1();
        assertEquals(this.counter.getCount(), -1);
        this.counter.sub1();
        this.counter.sub1();
        assertEquals(this.counter.getCount(), -3);
    }

    @Test
    public void reset() {
        assertEquals(this.counter.getCount(), 0);
        this.counter.add1();
        assertEquals(this.counter.getCount(), 1);
        this.counter.add1();
        this.counter.add1();
        assertEquals(this.counter.getCount(), 3);
        this.counter.reset();
        assertEquals(this.counter.getCount(), 0);
    }

    @Test
    public void mixed() {
        assertEquals(this.counter.getCount(), 0);
        this.counter.add1();
        assertEquals(this.counter.getCount(), 1);
        this.counter.sub1();
        assertEquals(this.counter.getCount(), 0);
        this.counter.add1();
        this.counter.add1();
        assertEquals(this.counter.getCount(), 2);
        this.counter.reset();
        this.counter.add1();
        this.counter.add1();
        this.counter.add1();
        this.counter.sub1();
        assertEquals(this.counter.getCount(), 2);
    }
}
