/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tests;

import models.Counter;
import org.junit.Before;
import org.junit.Test;
import views.CounterView;
import static org.junit.Assert.*;

/**
 *
 * @author forellana
 */
public class CounterViewTest {
    private CounterView gui;
    private Counter counter;

    @Before
    public void setUp() {
        counter = new Counter();
        gui = new CounterView(counter);
    }

    @Test
    public void initTest() {
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());
    }

    @Test
    public void addTest(){
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());

        addClick();
        assertTrue(isSameCount());
        assertEquals(1, counter.getCount());

        addClick();
        addClick();
        assertTrue(isSameCount());
        assertEquals(3, counter.getCount());
    }

    @Test
    public void subTest(){
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());

        subClick();
        assertTrue(isSameCount());
        assertEquals(-1, counter.getCount());

        subClick();
        subClick();
        assertTrue(isSameCount());
        assertEquals(-3, counter.getCount());
    }

    @Test
    public void resetTest(){
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());

        addClick();
        addClick();
        assertEquals(2, counter.getCount());

        resetClick();
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());
    }

    @Test
    public void mixedTest(){
        assertTrue(isSameCount());
        assertEquals(0, counter.getCount());

        subClick();
        subClick();
        subClick();
        addClick();
        assertTrue(isSameCount());
        assertEquals(-2, counter.getCount());

        resetClick();
        addClick();
        addClick();
        addClick();
        subClick();
        addClick();
        addClick();
        assertTrue(isSameCount());
        assertEquals(4, counter.getCount());
    }

    private boolean isSameCount(){
        return counter.getCount() == getLabeledCount();
    }

    public void subClick() {
        gui.minus.doClick();
    }

    public void addClick() {
        gui.plus.doClick();
    }

    public void resetClick() {
        gui.reset.doClick();
    }

    public int getLabeledCount() {
        return Integer.parseInt(gui.value.getText());
    }

}